﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace C1DateEditEnter
{
  public partial class DialogWithModifiedDateEdit : Form
  {
    public DialogWithModifiedDateEdit()
    {
      InitializeComponent();

      this.c1DateEdit1.Value = DateTime.Today;
      this.c1DateEdit1.FormatType = C1.Win.Input.FormatType.ShortDate;

      //This does not work => Escape is not handled:
      this.c1DateEdit1.AcceptsEscape = false;
      //this.c1DateEdit1.AcceptsEscape = true;
    }

    private void c1DateEdit1_KeyDown(object sender, KeyEventArgs e)
    {
      Trace.WriteLine("c1DateEdit1_KeyDown: " + e.KeyData);
    }

    public DateTime Value
    {
      get
      {
        return (DateTime)this.c1DateEdit1.Value;
      }
    }


    private void c1DateEdit1_ValueChanged(object sender, EventArgs e)
    {
      this.textBoxLog.AppendText("c1DateEdit1_ValueChanged: " + this.c1DateEdit1.Value + Environment.NewLine);
      Trace.WriteLine("c1DateEdit1_ValueChanged: " + this.c1DateEdit1.Value);

      MessageBox.Show(this, "Value Changed: " + this.c1DateEdit1.Value);
    }

    private void buttonOK_Click(object sender, EventArgs e)
    {
      this.textBoxLog.AppendText("buttonOK_Click: " + this.c1DateEdit1.Value + Environment.NewLine);

      if (((DateTime)this.c1DateEdit1.Value).Year < 2023)
      {
        MessageBox.Show(this, "Invalid year!");
        this.DialogResult = DialogResult.None;
      }
      else
      {
        MessageBox.Show(this, "Everything is OK: " + this.c1DateEdit1.Value);
      }
    }
  }
}
